const system = require("../../../system");
var settings = require("../../../../config/settings");
var APIBase = require("../../api.base");

class TradetransferAPI extends APIBase {
  constructor() {
    super();
    this.execlient = system.getObject("util.execClient");
    this.channelApiUrl = settings.channelApiUrl();
    this.appInfo = {
      aliyuntmtransfer: { appkey: settings.appKey, secret: settings.secret }
    };
  }

  async getToken() {
    var self = this;
    var reqTokenUrl = this.channelApiUrl + "/auth/accessAuth/getToken";
    var reqParam = self.appInfo["aliyuntmtransfer"];
    if (!reqParam.appkey || !reqParam.secret) {
      return system.getResult(null, "reqType类型有误，请求失败");
    }
    var rtn = await this.execlient.execPost(reqParam, reqTokenUrl);
    if (!rtn.stdout) {
      return system.getResult(null, "获取token失败");
    }
    var tokenResult = JSON.parse(rtn.stdout);
    if (tokenResult.status == 0) {
      tokenResult.data.secret = reqParam.secret;
    }
    return tokenResult;
  }


  /**
      * 接口跳转-POST请求
      * actionProcess  执行的流程
      * actionType     执行的类型
      * actionBody     执行的参数
      */
  async springBoard(pobj, qobj, req) {
    console.log(pobj);
    console.log(req);
    if (!pobj.actionProcess) {
      return system.getResult(null, "actionProcess参数不能为空");
    }
    if (!pobj.action_type) {
      return system.getResult(null, "actionType参数不能为空");
    }
    console.log(pobj);
    // var result = await this.opActionProcess(pobj.actionProcess, pobj.actionType, pobj.actionBody, req);
    // return result;
  }
  // async opActionProcess(action_process, action_type, action_body, req) {
  //   var opResult = null;
  //   settings.channelApiUrl+""
  //   var sobj = {
  //     "actionProcess": "aliyuntmtransfer",
  //     "actionType": "aliclient",
  //     "sign": "2FviZ9PGws8Pt1fBhq0t90mjUvI",
  //     "isUser": "yes",
  //     "actionBody": action_body
  //   }
  //   var tokenInfo = await this.getToken();
  //   var url = this.centerChannelUrl + "/action/tradetransfer/createtransfer";
  //   var rtn = await this.execlient.execPostTK(sobj, url, tokenInfo.data.token);
  //   return rtn;
  // }

  

}
module.exports = TradetransferAPI;
