﻿var url = require("url");
var system = require("../../base/system");
// var userSve = system.getObject("service.auth.userSve");
const logCtl = system.getObject("service.common.oplogSve");
const utilsNeedSve = system.getObject("service.utilsSve.utilsNeedSve");

module.exports = function (app) {

	app.use('/api/ali/esp/intention/submit', async function (req, res) {
		try {
			if (req.headers['content-type'] === 'application/octet-stream') {
				await logCtl.applicationOctetStream2Json(req);
			}
			var client_ip = system.get_client_ip(req);
			req.body.action_type = "submitNeed";
			var result = await utilsNeedSve.reqcenterchannel(req.body, client_ip);
			logCtl.info({
				optitle: (new Date()).Format("yyyy-MM-dd hh:mm:ss") + "回调处理订单结果：，method=" + req.body.trxcode,
				op: "api/ali/esp/intention/submit",
				content: "回调参数：" + JSON.stringify(req.body) + "回调处理订单结果：" + JSON.stringify(result),
				clientIp: client_ip || ""
			});
			res.end(JSON.stringify(result));
			return JSON.stringify(result);
		} catch (error) {
			logCtl.error({
				optitle: (new Date()).Format("yyyy-MM-dd hh:mm:ss") + "记录回调处理结果异常：，method=" + req.body.trxcode,
				op: "/api/ali/esp/intention/submit",
				content: "回调参数：" + JSON.stringify(req.body) + "error：" + error.stack,
				clientIp: client_ip || ""
			});
			return JSON.stringify(result);
		}
	});
	app.use('/api/ali/esp/intention/solution/feedback', async function (req, res) {
		try {
			if (req.headers['content-type'] === 'application/octet-stream') {
				await logCtl.applicationOctetStream2Json(req);
			}
			var client_ip = system.get_client_ip(req);
			req.body.action_type = "receiveFeedback";
			var result = await utilsNeedSve.reqcenterchannel(req.body, client_ip);
			logCtl.info({
				optitle: (new Date()).Format("yyyy-MM-dd hh:mm:ss") + "回调处理订单结果：，method=" + req.body.trxcode,
				op: "/api/ali/esp/intention/solution/feedback",
				content: "回调参数：" + JSON.stringify(req.body) + "回调处理订单结果：" + JSON.stringify(result),
				clientIp: client_ip || ""
			});
			res.end(JSON.stringify(result));
			return JSON.stringify(result);
		} catch (error) {
			logCtl.error({
				optitle: (new Date()).Format("yyyy-MM-dd hh:mm:ss") + "记录回调处理结果异常：，method=" + req.body.trxcode,
				op: "/api/ali/esp/intention/solution/feedback",
				content: "回调参数：" + JSON.stringify(req.body) + "error：" + error.stack,
				clientIp: client_ip || ""
			});
		}
	});
	app.use('/api/ali/ic/paySuccess', async function (req, res) {
		try {
			if (req.headers['content-type'] === 'application/octet-stream') {
				await logCtl.applicationOctetStream2Json(req);
			}
			var client_ip = system.get_client_ip(req);
			req.body.action_type = "paySuccess";
			var result = await utilsNeedSve.paySuccess(req.body, client_ip);
			logCtl.info({
				optitle: (new Date()).Format("yyyy-MM-dd hh:mm:ss") + "回调处理订单结果：，method=" + req.body.trxcode,
				op: "/api/ali/ic/paySuccess",
				content: "回调参数：" + JSON.stringify(req.body) + "回调处理订单结果：" + JSON.stringify(result),
				clientIp: client_ip || ""
			});
			res.end(JSON.stringify(result));
			return JSON.stringify(result);
		} catch (error) {
			logCtl.error({
				optitle: (new Date()).Format("yyyy-MM-dd hh:mm:ss") + "记录回调处理结果异常：，method=" + req.body.trxcode,
				op: "/api/ali/ic/paySuccess",
				content: "回调参数：" + JSON.stringify(req.body) + "error：" + error.stack,
				clientIp: client_ip || ""
			});
		}
	});
	app.use('/api/ali/esp/intention/close', async function (req, res) {
		try {
			if (req.headers['content-type'] === 'application/octet-stream') {
				await logCtl.applicationOctetStream2Json(req);
			}
			var client_ip = system.get_client_ip(req);
			req.body.action_type = "needClose";
			var result = await utilsNeedSve.reqcenterchannel(req.body, client_ip);
			logCtl.info({
				optitle: (new Date()).Format("yyyy-MM-dd hh:mm:ss") + "回调处理订单结果：，method=" + req.body.trxcode,
				op: "/api/ali/esp/intention/close",
				content: "回调参数：" + JSON.stringify(req.body) + "回调处理订单结果：" + JSON.stringify(result),
				clientIp: client_ip || ""
			});
			res.end(JSON.stringify(result));
			return JSON.stringify(result);
		} catch (error) {
			logCtl.error({
				optitle: (new Date()).Format("yyyy-MM-dd hh:mm:ss") + "记录回调处理结果异常：，method=" + req.body.trxcode,
				op: "/api/ali/esp/intention/close",
				content: "回调参数：" + JSON.stringify(req.body) + "error：" + error.stack,
				clientIp: client_ip || ""
			});
		}
	});
	app.get('/api/:gname/:qname/:method', function (req, res) {
		var classPath = req.params["qname"];
		var methodName = req.params["method"];
		var gname = req.params["gname"];

		classPath = gname + "." + classPath;
		var tClientIp = system.get_client_ip(req);
		req.clientIp = tClientIp;
		req.uagent = req.headers["user-agent"];
		req.classname = classPath;

		var params = [];
		params.push(gname);
		params.push(methodName);
		params.push(req.body);
		params.push(req.query);
		params.push(req);
		var p = null;
		var invokeObj = system.getObject("api." + classPath);
		if (invokeObj["doexec"]) {
			p = invokeObj["doexec"].apply(invokeObj, params);
		}
		p.then(r => {
			res.end(JSON.stringify(r));
		});
	});
	app.post('/api/:gname/:qname/:method', function (req, res) {
		var classPath = req.params["qname"];
		var methodName = req.params["method"];
		var gname = req.params["gname"];
		var params = [];
		classPath = gname + "." + classPath;
		var tClientIp = system.get_client_ip(req);

		req.clientIp = tClientIp;
		req.uagent = req.headers["user-agent"];
		req.classname = classPath;

		params.push(gname);
		params.push(methodName);
		params.push(req.query);
		params.push(req.body);
		params.push(req);
		var p = null;
		var invokeObj = system.getObject("api." + classPath);
		if (invokeObj["doexec"]) {
			p = invokeObj["doexec"].apply(invokeObj, params);
		}
		p.then(r => {
			res.end(JSON.stringify(r));
		});
	});
	app.post('/:gname/:qname/:method', function (req, res) {
		var classPath = req.params["qname"];
		var methodName = req.params["method"];
		var gname = req.params["gname"];
		var params = [];
		classPath = gname + "." + classPath;
		var tClientIp = system.get_client_ip(req);

		req.clientIp = tClientIp;
		req.uagent = req.headers["user-agent"];
		req.classname = classPath;

		params.push(gname);
		params.push(methodName);
		params.push(req.body);
		params.push(req.query);
		params.push(req);
		var p = null;
		var invokeObj = system.getObject("api." + classPath);
		if (invokeObj["doexec"]) {
			p = invokeObj["doexec"].apply(invokeObj, params);
		}
		p.then(r => {
			res.end(JSON.stringify(r));
		});
	});
};
